/*
**	disp.c
**
*/
#include "mpeg.h"
#include "disp.h"
#define Simple4

/*
**
	m0   m1   m2   m3
	   c         c
	m4   m5   m6   m7

	m8   m9   ma   mb
	   c         c
	mc   md   me   mf
**
*/
#define M0	0
#define	M1	16
#define	M2	4
#define	M3	20
#define	M4	24
#define	M5	8
#define	M6	28
#define	M7	12
#define	M8	6
#define	M9	22
#define	MA	2
#define	MB	18
#define	MC	30
#define	MD	14
#define	ME	26
#define	MF	10

#define O 256
#define RGBD(l,M,S) (y=(l>>S)&255,(r[y+M-O]|g[y+M+O]|b[y+2*M-O])<<S)
		

disp0(sif)
Ui	*sif;
{
Us *cb;
Ui *ip,*yp;
int	i,j,hx,wx,wy;
int	wx2,hx2;
int y,u,v;
Ui h,n,l,m;
Ui *r,*g,*b;
Ui a,c;
int	brd=xys>>3;
static int inv= 0;

hx= dx>>2;
wx= wix>>2;
wx2= wx<<1;
hx2= hx<<1;
ip= (Ui *)dd;
yp= sif;
cb= (Us *)(sif+(xys>>2));

if(inv^=1)
for(j=0;j<winh;j+=4){
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,M0,24); n+= RGBD(m,M1,16);
		h = RGBD(l,M4,24); h+= RGBD(l,M5,16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,M2,8); n+= RGBD(m,M3,0);
		h+= RGBD(l,M6,8); h+= RGBD(l,M7,0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,M8,24); n+= RGBD(m,M9,16);
		h = RGBD(l,MC,24); h+= RGBD(l,MD,16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,MA,8); n+= RGBD(m,MB,0);
		h+= RGBD(l,ME,8); h+= RGBD(l,MF,0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	}
else
for(j=0;j<winh;j+=4){
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,(30-M0),24); n+= RGBD(m,(30-M1),16);
		h = RGBD(l,(30-M4),24); h+= RGBD(l,(30-M5),16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,(30-M2),8); n+= RGBD(m,(30-M3),0);
		h+= RGBD(l,(30-M6),8); h+= RGBD(l,(30-M7),0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,(30-M8),24); n+= RGBD(m,(30-M9),16);
		h = RGBD(l,(30-MC),24); h+= RGBD(l,(30-MD),16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,(30-MA),8); n+= RGBD(m,(30-MB),0);
		h+= RGBD(l,(30-ME),8); h+= RGBD(l,(30-MF),0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	}
}
/*
**	4x4 RGB dither enlarged
*/
#define O 256
#define RGB(M) (r[y+M-O]|g[y+M+O]|b[y+2*M-O])
disp02(sif)
Uc	*sif;
	{
	Uc *cb;
	Us *yp;
	Ui *ip;
	int	i,j,hcs,wx,wy;
	int	wx2,wx3;
	int	brd=xys>>2;
	int	y,u,v,d;
	Ui	*r,*g,*b;
	Ui	l,m,t;

	hcs= dx>>1;
	wx= wix>>2;
	wx2= wix>>1;
	wx3= wx2+wx;
	wy= winh>>2;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<wy;j++){
		i= wx;
		do{
		v= cb[brd];
		u= *cb++;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		d= yp[hcs]; y= d>>8;
		t= RGB(MA);
		l= t<<16; m= t&0xffff0000;
		y= (Uc)d;
		t= RGB(M8);
		l|= t&0xffff; m|= t>>16;
		ip[wx3]= m;
		ip[wx2]= l;
		d= *yp++; y= d>>8;
		t= RGB(M2);
		l= t<<16; m= t&0xffff0000;
		y= (Uc)d;
		t= RGB(M0);
		l|= t&0xffff; m|= t>>16;
		ip[wx]= m;
		*ip++ = l;
		}while(--i);
		yp+= hcs; ip+= wx3;
		}
	}

/*
**	4x4 RGB dither 4x4 enlarged
*/
#ifdef LE
#define Q0 0
#define Q1 1
#else
#define Q0 1
#define Q1 0
#endif
disp04(yp)
Us	*yp;
	{
	Uc *cb;
	Ui *ip;
	int	i,j,hcs,wx,wy;
	int	wx2,wx3;
	int	crd=xys>>2;
	int	y,u,v,d;
	Ui	*r,*g,*b;
	Us	yy;
	Ui	l,m,t;

	hcs= dx>>1;
	wx=  wix>>2;
	wx2= wix>>1;
	wx3= wx2+wx;
	wy= winh>>2;
	ip= (Ui *)dd;
	cb= (Uc *)yp+xys;

	for(j=0;j<wy;j++){
	for(i=0;i<wx;i+=2){
		v= cb[crd+(i>>1)];
		u= cb[(i>>1)];
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		yy= yp[i>>1];
		y= (Uc)yy;
#ifdef Simple4
		t= RGB(M0);
		l= t>>16|t<<16;
		ip[wx3+i]= l; ip[wx2+i]= t;
		ip[wx+i]= t; ip[i] = l;
#else
		t= RGB(MA); l= t<<16; m= t&0xffff0000;
		t= RGB(M8); l|= t&0xffff; m|= t>>16;
		ip[wx3+i+Q0]= m; ip[wx2+i+Q0]= l;
		t= RGB(M2); l= t<<16; m= t&0xffff0000;
		t= RGB(M0); l|= t&0xffff; m|= t>>16;
		ip[wx+i+Q0]= m; ip[i+Q0] = l;
#endif
		y= yy>>8;
#ifdef Simple4
		t= RGB(M0); 
		l= t>>16|t<<16;
		ip[wx3+i+1]= l; ip[wx2+i+1]= t;
		ip[wx+i+1]= t; ip[i+1] = l;
#else
		y= yy>>8;
		t= RGB(MA); l= t<<16; m= t&0xffff0000;
		t= RGB(M8); l|= t&0xffff; m|= t>>16;
		ip[wx3+i+Q1]= m; ip[wx2+i+Q1]= l;
		t= RGB(M2); l= t<<16; m= t&0xffff0000;
		t= RGB(M0); l|= t&0xffff; m|= t>>16;
		ip[wx+i+Q1]= m; ip[i+Q1] = l;
#endif
		}
		if(j&1)cb+= hcs;
		ip+= wix;
		yp+= hcs;
		}
	}
/*
**	3x3 RGB dither 3x3 enlaged
*/
#define T(M) (r[y+M-O]|g[y+M+O]|b[y+M-O])
#ifdef LE
#define O0 0
#define O1 1
#define O2 2
#else
#define O0 2
#define O1 1
#define O2 0
#endif
disp03(sif)
Uc	*sif;
	{
	Us *cb;
	Ui *ip;
	int	i,j,wx,wx2,brd= xys>>3;
#ifdef Long64
	Ul	*r,*g,*b,t,t2;
#else
	Ui	*r,*g,*b,t,t2;
#endif
	Ui	*yp,d,l,m,n;
	Ui	uu,vv;
	Uc	y,u,v;

	wx=  wix>>2;
	wx2= wix>>1;
	ip= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)yp+(xys>>1);
	for(j=0;j<winh/3;j++){
		yp= (Ui *)(sif+j*dx);
		ip= (Ui *)(dd+3*j*wix);
	for(i=0;i<wx;i+=3,ip+=3){
		vv= *(cb+brd); uu= *cb++;
		u= uu; v= vv;
#ifdef Long64
		r= (Ul *)(&Q)+256+(v<<1);
		g= (Ul *)(&Q)+1024-u-v;
		b= (Ul *)(&Q)+(1024+768)+(u<<1);
		d= *yp++; y= d; t= RGB(0); l= t;
		m= t>>24; n= t>>40;
#else
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		d= *yp++; y= d; t= RGB(0); l= t;
		t= T(768*3); m= t<<8 | l>>24; n= t>>8;
#endif
		l&= 0xffffff; m&= 0xffffff;
		y= d>>8; t= RGB(0);
		*(ip+O0) = t<<24 | l;
		*(ip+wx+O0)= (      t&0xff000000) | m;
#ifdef Long64
		*(ip+wx2+O0)= ((t>>16)&0xff000000) | n;
		l= t>>8; m= t>>32; n= t>>48;
#else
		l= t>>8; t= T(768*3);
		*(ip+wx2+O0)= ((t&0xff00)<<16) | n;
		m= t; n= t>>16;
#endif
		l&=0xffff; m&= 0xffff;

		u= uu>>8; v= vv>>8;
#ifdef Long64
		r= (Ul *)(&Q)+256+(v<<1);
		g= (Ul *)(&Q)+1024-u-v;
		b= (Ul *)(&Q)+(1024+768)+(u<<1);
		y= d>>16; t= RGB(0);
		*(ip+O1)= (t&0xffff)<<16 | l;
		*(ip+wx +O1)= ((t>> 8)&0xffff0000) | m;
		*(ip+wx2+O1)= ((t>>24)&0xffff0000) | n;
		m= t>>40; l= t>>16; n= t>>56;
#else
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		y= d>>16; t= RGB(0);
		*(ip+O1)= (t&0xffff)<<16 | l;
		t2= T(768*3);
		*(ip+wx +O1)= t2<<24 | ((t>>8)&0xff0000) | m;
		*(ip+wx2+O1)= ((t2<<8)&0xffff0000) | n;
		l= t>>16; m= t2>>8; n= t2>>24;
#endif
		l&=255; m&=255;
		y= d>>24; t= RGB(0);
		*(ip+O2)= t<<8 | l;
#ifdef Long64
		*(ip+wx +O2)= ((t>>16)&0xffffff00) | m;
		*(ip+wx2+O2)= ((t>>32)&0xffffff00) | n;
#else
		t2= T(768*3);
		*(ip+wx +O2)= (t2&0xffff)<<16 | ((t>>16)&0xff00) | m;
		*(ip+wx2+O2)= (t2&0xffffff00) | n;
#endif
		}
		if((j&1)==0)cb-= (dx>>2);
		}
	}

disp3z(sif)
Uc	*sif;
	{
	Uc	*cb,*cr;
	Us	*yp;
	Ui	*ip;
	int	i,j,hcs,wx,wy,wy1,wy2,wx1,wx2;
	int	u,v,d,l,m;
	Uc	y;
	Ui	*r,*g,*b,t;
	int	sx,sy;
	int	x,iy;

	wx= wix; wy= wiy;
	hcs= dx>>1;
	wx1= wx>>1; wx2= wx>>2;
	wy1= wy>>1; wy2= wy>>2;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys; cr= cb+(xys>>2);

	sy= iy= 0;
	for(j=0;j<wy;){
		if(sy>=0){ sy-= wy1;
			yp= (Us *)(sif+iy*dx);
			cb= sif+xys+hcs*(iy>>1); cr= cb+(xys>>2);
			ip= (Ui *)(dd+j*wx);
			sx= x= 0;
			for(i=0;i<wx1;){
				if(sx>=0){ sx-= wx1; /* get uv,y */
					if((x++&1)==0){
						int x1= x>>1;
						u= cb[x1]; v= cr[x1];
				r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
						d= yp[x1]; y= d;
						}
					else y= d>>8;
					t= RGB(0);
					}
			    	  else { sx+= dx; /* save colorm */
					if(i++&1){
						l|= t<<16; m|= t&0xffff0000;
						*(ip+wx2)= m; *ip++ = l;
						}
					 else {
						l= t&0xffff; m= t>>16;
						}
					}
				}
			iy++;
			}
		else {
			sy+= ddy; j+= 2;
			while(sy<0 && j<wy){
				ip= (Ui *)(dd+j*wx);
				for(i=0;i<wx1;i++) ip[i]= ip[i-wx1];
				sy+= ddy; j+= 2;
				}
			}
		}
	}

/*
**	disp9.c
**	Full color
*/

#ifdef LE	/* Little-Endian Client */
#define	P0	0
#define	P1	8
#define	P2	16
#define	P3	24
#define C0	0
#define C8	8
#else		/* Big-Endian Client */
#define	P0	24
#define	P1	16
#define	P2	8
#define	P3	0
#define C0	8
#define C8	0
#endif

/*
#define rgb(u,v) r= Q.r+(v<<1);g= Q.g-u-v;b= Q.b+(u<<1)
*/
#define rgb(u,v) {int a= v+(v>>1);\
		int c= u+(u>>1);\
		r= Q.r+a;\
		g= Q.g-(a>>1)-(c>>2);\
		b= Q.b+c;}

extern Visual *vis;
extern int dep;
static int boex= 0;

disp9(sif)
Uc	*sif;
	{
	Us *cb,*cr;
	Ui *sp,*yp;
	int	i,j,hcs,wx,wy;
#ifdef LE
	if(ImageByteOrder(dpy)==MSBFirst) boex= 1;
#else
	if(ImageByteOrder(dpy)==LSBFirst) boex= 1;
#endif
	hcs= dx>>2;
	wx= winw;
	wy= winh;
	sp= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)(sif+xys);
	cr= (Us *)(sif+xys+(xys>>2));

			 if(dep<=8)disp91(sif);
	else if(dep<=16 && boex==0)disp92(sif);
	else if(dep<=32 && boex==0)disp93(sif);
	else 
	for(j=0;j<wy;j+=2){
	for(i=0;i<wx;i+=4){
		int	y,u,v;
		Ui cbd,crd,*r,*g,*b,h,l,a,c,t;

		cbd= *cb++; crd= *cr++;
		u= (Uc)(cbd>>C0)-128; v= (Uc)(crd>>C0)-128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>P0); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+0,j+0,t);
		y= (Uc)(h>>P1); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+1,j+0,t);
		y= (Uc)(l>>P0); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+0,j+1,t);
		y= (Uc)(l>>P1); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+1,j+1,t);

		u= (Uc)(cbd>>C8)-128; v= (Uc)(crd>>C8)-128;
		rgb(u,v);
		y= (Uc)(h>>P2); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+2,j+0,t);
		y= (Uc)(h>>P3); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+3,j+0,t);
		y= (Uc)(l>>P2); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+2,j+1,t);
		y= (Uc)(l>>P3); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+3,j+1,t);
		}
		yp+= hcs; sp+= wx>>2;
		}
	}

/*
**	256 True colors
*/
disp91(sif)
Uc	*sif;
	{
	Us *cb,*cr;
	Ui *sp,*yp;
	int	i,j,hcs,wx,wy;

	hcs= dx>>2;
	wx= winw>>2;
	wy= winh>>1;
	sp= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)(sif+xys);
	cr= (Us *)(sif+xys+(xys>>2));

	for(j=0;j<wy;j++){
	for(i=0;i<wx;i++){
		int	y,u,v;
		Ui cbd,crd,*r,*g,*b,h,l,a,c;

		cbd= *cb++; crd= *cr++;
		u= (Uc)(cbd>>C0)-128; v= (Uc)(crd>>C0)-128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>P0); a = (r[y]|g[y]|b[y])<<P0;
		y= (Uc)(h>>P1); a|= (r[y]|g[y]|b[y])<<P1;
		y= (Uc)(l>>P0); c = (r[y]|g[y]|b[y])<<P0;
		y= (Uc)(l>>P1); c|= (r[y]|g[y]|b[y])<<P1;

		u= (Uc)(cbd>>C8)-128; v= (Uc)(crd>>C8)-128;
		rgb(u,v);
		y= (Uc)(h>>P2); a|= (r[y]|g[y]|b[y])<<P2;
		y= (Uc)(h>>P3); a|= (r[y]|g[y]|b[y])<<P3;
		y= (Uc)(l>>P2); c|= (r[y]|g[y]|b[y])<<P2;
		y= (Uc)(l>>P3); c|= (r[y]|g[y]|b[y])<<P3;
		*(sp+wx)= c;
		*sp++= a;
		}
		yp+= hcs; sp+= wx;
		}
	}

/*
**	65536 True Colors
*/
disp92(sif)
Uc	*sif;
	{
	Uc *cb,*cr;
	Us *yp;
	Ui *sp;
	int	i,j,hcs,wx,wy;

	hcs= dx>>1;
	wx= winw>>1;
	wy= winh>>1;
	sp= (Ui *)dd;
	yp= (Us *)sif;
	cb= (Uc *)(sif+xys);
	cr= (Uc *)(sif+xys+(xys>>2));

	for(j=0;j<wy;j++){
	for(i=0;i<wx;i++){
		int	y,u,v;
		Ui *r,*g,*b,h,l,a,c;
		u= *cb++ -128; v= *cr++ -128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(l>>C0); a = (r[y]|g[y]|b[y])<<C0*2;
		y= (Uc)(l>>C8); a|= (r[y]|g[y]|b[y])<<C8*2;
		y= (Uc)(h>>C0); c = (r[y]|g[y]|b[y])<<C0*2;
		y= (Uc)(h>>C8); c|= (r[y]|g[y]|b[y])<<C8*2;
		sp[wx]= a;
		*sp++ = c;
		}
		yp+= hcs; sp+= wx;
		}
	}

/*
**	2^24 True Colors (4 byte pixel)
*/
disp93(sif)
Uc	*sif;
	{
	Uc *cb,*cr;
	Us *yp;
	Ui *sp;
	int	i,j,hcs,wx,wy,wx2;

	hcs= dx>>1;
	wx= winw>>1;
	wx2= winw;
	wy= winh>>1;
	sp= (Ui *)dd;
	yp= (Us *)sif;
	cb= (Uc *)(sif+xys);
	cr= (Uc *)(sif+xys+(xys>>2));
	for(j=0;j<wy;j++){
	for(i=0;i<wx;i++){
		int	y,u,v;
		Ui *r,*g,*b,h,l;
		u= *cb++ -128; v= *cr++ -128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>C0); sp[0]=     r[y]|g[y]|b[y];
		y= (Uc)(h>>C8); sp[1]=     r[y]|g[y]|b[y];
		y= (Uc)(l>>C0); sp[wx2]=   r[y]|g[y]|b[y];
		y= (Uc)(l>>C8); sp[wx2+1]= r[y]|g[y]|b[y];
		sp+=2;
		}
		yp+= hcs; sp+= wx2;
		}
	}
