/*
**	exp.c
*/
#include "mpeg.h"
#include "disp.h"
/*
** expand()
*/
expand(p1,q,wx,wy,lbp,zlinebuff)
Uc *p1;
Ui *q;
Ui *zlinebuff;
	{
	Uc d;
	int i,j,sx,sy,x,y;
	int w= (wx>>2)<<lbp;

	if(x2==1){
		Ui *p= (Ui *)p1;
		int len= ((wix*wy)<<lbp)/sizeof(Ui);
		for(j=0;j<len;j+=4){
			q[j  ]= p[j  ]; q[j+1]=p[j+1];
			q[j+2]= p[j+2]; q[j+3]=p[j+3];
			}
		}
	else if(x2==2){
		for(j=0;j<wy;j+=2){ 
			if(lbp==0){
				Us *p= (Us *)p1;
				for(i=0;i<(dx>>1);i++){
					Ui d= p[i];
					d= (d&(255<<8))<<8 | (d&255);
					q[i+w]= q[i]= d|d<<8;
					}
				}
			else if(lbp==1) {
				Us *p= (Us *)p1;
				for(i=0;i<dx;i++){
					Ui d= p[i];
					q[i+w]= q[i]= d|d<<16;
					}
				}
			else if(lbp==2) {
				Ui *p= (Ui *)p1;
				for(i=0;i<dx;i++)
				 q[2*i+w+1]= q[2*i+w]= q[2*i+1]= q[2*i]= p[i];
				}
			p1+= dx<<lbp;
			q+= w*2;
			}
		}
	else if(x2==3){
		Ui *p= (Ui *)p1;
		int ix= (dx>>2)<<lbp;
		for(j=0;j<ddy;j++){ 
			int k;
			if(lbp==0) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
				Uc d0= d; Uc d1= d>>8;
				Uc d2= d>>16; Uc d3= d>>24;
#ifdef LE
				q[i  ]= d1<<24 | d0*((1<<16)+257);
				q[i+1]= (d2<<16 | d1)*257;
				q[i+2]= d3*(((1<<16)+257)<<8) | d2;
#else
				q[i+2]= d1<<24 | d0*((1<<16)+257);
				q[i+1]= (d2<<16 | d1)*257;
				q[i  ]= d3*(((1<<16)+257)<<8) | d2;
#endif
				}
			else if(lbp==1) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
#ifdef LE
				Us d0= d;
				Us d1= d>>16;
#else
				Us d1= d;
				Us d0= d>>16;
#endif
				q[i  ]= d0<<16|d0;
				q[i+1]= d1<<16|d0;
				q[i+2]= d1<<16|d1;
				}
			else if(lbp==2) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
				q[i+2]= q[i+1]= q[i  ]= d;
				}
			for(k=0;k<w;k++)
				q[k+w*2]=q[k+w]=q[k];
			q+= w*3;
			}
		}
	else if(x2==4){
		Ui *p= (Ui *)p1;
		int wx1= (wix>>2)<<lbp;
		int wx2= (wix>>1)<<lbp;
		int wx3= wx2+wx1;
		int ix= dx<<lbp;
		for(j=0;j<ddy;j++){ 
			if(lbp==0) for(i=0;i<dx;i++){
				Ui d= p1[i];
				d|= d<<8;
				q[i]= d<<16 | d;
				}
			else if(lbp==1) for(i=0;i<dx;i++){
				Ui d= *((Us *)p1+i);
				q[2*i+1]= q[2*i]= d<<16 | d;
				}
			else if(lbp==2) for(i=0;i<dx;i++){
				q[4*i+3]= q[4*i+2]= q[4*i+1]= q[4*i]= p[i];
				}
			for(i=0;i<((wx>>2)<<lbp);i++)
				q[i+wx3]= q[i+wx2]= q[i+wx1]= q[i];
			p1+= ix;
			p+= (dx>>2)<<lbp;
			q+= wix<<lbp;
			}
		}
/* variable expansion */
	 else if(lbp==0){
		Uc *cc= (Uc *)zlinebuff;
		j= sy= y= 0;
		while(j<wy)
		  if(sy>=0){
			i= sx= x= 0;
			while(i<wx)
				if(sx>=0){ sx-= wx; d= p1[x++]; }
				else { sx+= dx; cc[i++]= d; }
			p1+= dx; sy-= wy;
			}
		   else {
			for(i=0;i<(wx>>2);i++) q[i]= zlinebuff[i];
			q+= wix>>2; sy+= ddy; j++;
			}
		}
	 else if(lbp==1){
		Us d,*sp= (Us *)zlinebuff;
		Us *p11= (Us *)p1;
		j= sy= y= 0;
		while(j<wy)
		  if(sy>=0){
			i= sx= x= 0;
			while(i<wx)
				if(sx>=0){ sx-= wx; d= p11[x++]; }
				else { sx+= dx; sp[i++]= d; }
			p11+= dx; sy-= wy;
			}
		   else {
			for(i=0;i<(wx>>1);i++) q[i]= zlinebuff[i];
			q+= wix>>1; sy+= ddy; j++;
			}
		}
	 else if(lbp==2){
		Ui d;
		Ui *p11= (Ui *)p1;
		j= sy= y= 0;
		while(j<wy)
		  if(sy>=0){
			i= sx= x= 0;
			while(i<wx)
				if(sx>=0){ sx-= wx; d= p11[x++]; }
				else { sx+= dx; zlinebuff[i++]= d; }
			p11+= dx; sy-= wy;
			}
		   else {
			for(i=0;i<wx;i++) q[i]= zlinebuff[i];
			q+= wix; sy+= ddy; j++;
			}
		}
	}
